import org.lwjgl.opengl.GL11;
import java.util.ArrayList;

public class CelestialBody {

    float orbitalDistance;
    float scale;
    float speed;
    float angularPos;
    float declination;
    float inclination;
    Sphere s;

    ArrayList<CelestialBody> satellites = new ArrayList<CelestialBody>();

    public CelestialBody(Sphere s,
		  float dist, float scale,
		  float startPos, float inclination,
		  float declination) {
	this.s = s;
	this.orbitalDistance = dist;
	this.scale = scale;
        if (Math.abs(dist) >= 1f)
            this.speed = 1f/dist;
        else
            this.speed = 0f;
	this.angularPos = startPos;
        this.inclination = inclination;
	this.declination = declination;
    }

    public void addSatellite(CelestialBody s) {
	satellites.add(s);
    }

    public void draw() {
	GL11.glPushMatrix();
        GL11.glRotatef(inclination, 0f, 0f, 1f);
	GL11.glRotatef(angularPos, 0f, 1f, 0f);
	GL11.glTranslatef(0f, 0f, orbitalDistance);
	GL11.glScalef(scale, scale, scale);

	for (CelestialBody sat : satellites) {
	    sat.draw();
	}

	GL11.glRotatef(declination, 1f, 0f, 0f);
	s.draw();

	GL11.glPopMatrix();
	angularPos += speed;
    }
}
