import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.LWJGLException;
import org.lwjgl.BufferUtils;
import org.lwjgl.input.Keyboard;

import java.util.ArrayList;
import java.nio.FloatBuffer;

/** No documentation for teh win! */
public class SolarSystem {

    public static final float[] x = new float[7];
    public static final float[] y = new float[7];

    private static float angle = 30f;
    private static float distance = -50f;

    Sphere sunSphere = new Sphere(8);
    Sphere s = new Sphere(4);
    ArrayList<CelestialBody> suns = new ArrayList<CelestialBody>();
    
    FloatBuffer lPos = BufferUtils.
        createFloatBuffer(4).put(new float[]
            {  0.0f,  0.0f,  0.0f, 1f});
    FloatBuffer lColor = BufferUtils.
        createFloatBuffer(4).put(new float[]
            { 0.25f, 0.3f, 0.4f, 1.0f });

    private void initGL() {
        // Initialisering
	GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	GL11.glShadeModel(GL11.GL_SMOOTH);

	GL11.glMatrixMode(GL11.GL_PROJECTION);
	GL11.glLoadIdentity();
        double size = Math.tan(60.0 / 360.0 * Math.PI) * 0.5;
	GL11.glFrustum(-size, size, -size, size, 0.5, 110.0);

	GL11.glMatrixMode(GL11.GL_MODELVIEW);
	GL11.glLoadIdentity();
        GL11.glTranslatef(0.0f, 0.0f, -5.0f);

        lColor.rewind();
        GL11.glLight(GL11.GL_LIGHT0,
                     GL11.GL_AMBIENT,
                     lColor);

        GL11.glColorMaterial(GL11.GL_FRONT_AND_BACK,
                             GL11.GL_AMBIENT_AND_DIFFUSE);
        GL11.glEnable(GL11.GL_CULL_FACE);
        GL11.glEnable(GL11.GL_LIGHTING);
        GL11.glEnable(GL11.GL_LIGHT0);
        GL11.glEnable(GL11.GL_DEPTH_TEST);
        GL11.glEnable(GL11.GL_NORMALIZE);
        GL11.glEnable(GL11.GL_POLYGON_SMOOTH);
        
    }

    private void display() {
	GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);
        
	GL11.glPushMatrix();
        GL11.glTranslatef(0.0f, 0.0f, distance);

        GL11.glRotatef(30f, 1f, 0f, 0f);
        GL11.glRotatef(angle, 0f, 1f, 0f);

        for (CelestialBody body : suns) {
            body.draw();
        }

        /*
	p1.draw();
	p2.draw();
	p3.draw();

	GL11.glEnable(GL11.GL_BLEND);
	GL11.glDisable(GL11.GL_LIGHTING);
	GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);
	GL11.glColor4f(1.0f, 0.5f, 0.25f, 0.5f);
	GL11.glScalef(0.8f, 0.8f, 0.8f);
	sun.draw();
	GL11.glScalef(1.15f, 1.15f, 1.15f);
	sun.draw();
	GL11.glScalef(1.1f, 1.1f, 1.1f);
	sun.draw();
	GL11.glScalef(1.05f, 1.05f, 1.05f);
	sun.draw();
	GL11.glScalef(1.01f, 1.01f, 1.01f);
	sun.draw();
        GL11.glEnable(GL11.GL_LIGHTING);
	GL11.glDisable(GL11.GL_BLEND);
        */
        GL11.glPopMatrix();
	GL11.glFlush();
	angle += 0.01f;
    }

    private void drawPoint(float[] p) {
        GL11.glVertex3f(p[0], p[1], p[2]);
    }
    /*
    private void switchColor() {
        red += 0.25f;
        green += 0.25f;
        blue += 0.25f;
	if (red > 1f)
	    red = 0f;
	if (green > 1f)
	    green = 0f;
	if (blue > 1f)
            blue = 0f;
    }
    */
    private void run() {
        init();

        while (!Display.isCloseRequested()) {
            long prev = System.nanoTime() / 1000000;
            if (Keyboard.isKeyDown(Keyboard.KEY_UP)) {
                distance = Math.min(0f, distance + 0.1f);
            } else if (Keyboard.isKeyDown(Keyboard.KEY_DOWN)) {
                distance = Math.max(-50f, distance - 0.1f);
            }

            if (Keyboard.isKeyDown(Keyboard.KEY_LEFT)) {
                angle = (angle + 0.1f) % 360f;
            } else if (Keyboard.isKeyDown(Keyboard.KEY_RIGHT)) {
                angle = (angle - 0.1f) % 360f;
            }

            display();
            Display.update();
            long delta = System.nanoTime() / 1000000 - prev;
            if (delta < 10) {
                try {
                    Thread.sleep(10 - delta);
                } catch (InterruptedException e) { }
            }
        }

        Display.destroy();
    }

    private void createRandomSolarSystem() {
        CelestialBody sun = new Sun(sunSphere,
                                    (float)(Math.random()*48.5+1.5),
                                    (float)(Math.random()*0.2+0.2),
                                    (float)(Math.random()*360.0),
                                    (float)(Math.random()*10.0-5.0),
                                    (float)(Math.random()*45.0+60.0),
                                    (float)(Math.random()*0.75+0.25),
                                    (float)(Math.random()*0.75+0.25),
                                    (float)(Math.random()*0.75+0.25));
        int planets = (int)(Math.random() * 6);
        for (int i = 0; i < planets; i++) {
            sun.addSatellite(new
                             CelestialBody(s,
                                           (float)(Math.random()*4+1.5),
                                           (float)(Math.random()*0.2+0.2),
                                           (float)(Math.random()*360),
                                           (float)(Math.random()*10-5),
                                           (float)(Math.random()*45+60)));
        }
        suns.add(sun);
    }

    private void init() {

        for (int i = 0; i < 100; i++) {
            createRandomSolarSystem();
        }

        try {
            Display.setTitle("Solar system!");
            Display.setDisplayMode(new DisplayMode(512, 512));
            Display.create();
        } catch (LWJGLException e) {
            System.err.println("Could't create display. Exiting");
            System.exit(0);
        }
        initGL();
    }

    public static void main(String[] args) {
        new SolarSystem().run();
    }
}
