import org.lwjgl.opengl.GL11;

public class Sphere {

    private float[] x;
    private float[] y;
    private int definition;

    public Sphere(int definition) {
	// A tiny cheat to allow negative values
        this.definition = definition = Math.abs(definition) + 2;

        x = new float[definition * 2 + 1];
        y = new float[definition * 2 + 1];

        double inc = Math.PI / definition;
        for (int i = 0; i < x.length; i++) {
            y[i] = (float)Math.sin(inc*i);
            x[i] = (float)Math.cos(inc*i);
        }
    }

    public void draw() {
        drawTop();

        for (int i = 1; i < definition - 1; i++) {
            GL11.glBegin(GL11.GL_QUAD_STRIP);
            for (int j = 0; j < x.length; j++) {
                GL11.glNormal3f(y[i]*x[j],
                                y[i]*y[j],
                                x[i]);
                GL11.glVertex3f(y[i]*x[j],
                                y[i]*y[j],
                                x[i]);
                GL11.glNormal3f(y[i+1]*x[j],
                                y[i+1]*y[j],
                                x[i+1]);
                GL11.glVertex3f(y[i+1]*x[j],
                                y[i+1]*y[j],
                                x[i+1]);
            }
            GL11.glEnd();
        }

        drawBottom();
    }

    private void drawTop() {
        GL11.glBegin(GL11.GL_TRIANGLE_FAN);
        GL11.glNormal3f(0f, 0f, 1f);
        GL11.glVertex3f(0f, 0f, 1f);
        for (int i = 0; i < x.length; i++) {
            GL11.glNormal3f(y[1]*x[i],
                            y[1]*y[i],
                            x[1]);
            GL11.glVertex3f(y[1]*x[i],
                            y[1]*y[i],
                            x[1]);
        }
        GL11.glEnd();
    }

    private void drawBottom() {
        GL11.glBegin(GL11.GL_TRIANGLE_FAN);
        GL11.glNormal3f(0f, 0f, -1);
        GL11.glVertex3f(0f, 0f, -1);
        for (int i = x.length-1; i >= 0; i--) {
            GL11.glNormal3f(y[1]*x[i],
                            y[1]*y[i],
                            x[definition + 1]);
            GL11.glVertex3f(y[1]*x[i],
                            y[1]*y[i],
                            x[definition + 1]);
        }
        GL11.glEnd();
    }

}
