import org.lwjgl.opengl.GL11;
import org.lwjgl.BufferUtils;
import java.nio.FloatBuffer;

public class Sun extends CelestialBody {

    private static final FloatBuffer lightPos = BufferUtils.
        createFloatBuffer(4).put(new float[]
            {  0.0f,  0.0f,  0.0f, 1f});
    FloatBuffer lightColor;
    float red, green, blue;

    public Sun(Sphere s,
               float dist, float scale,
               float startPos, float inclination,
               float declination) {
        this(s, dist, scale,
             startPos, inclination, declination,
             1f, 0.75f, 0.25f);
    }

    public Sun(Sphere s,
               float dist, float scale,
               float startPos, float inclination,
               float declination,
               float red, float green, float blue) {
        super(s, dist, scale, startPos, inclination, declination);
        this.red = red;
        this.green = green;
        this.blue = blue;
        lightColor = BufferUtils.createFloatBuffer(4).put(new float[] {
                red, green, blue, 1f });
        lightPos.rewind();
        lightColor.rewind();
    }

    public void draw() {
        
	GL11.glPushMatrix();
        GL11.glRotatef(inclination, 0f, 0f, 1f);
	GL11.glRotatef(angularPos, 0f, 1f, 0f);
	GL11.glTranslatef(0f, 0f, orbitalDistance);
	GL11.glScalef(scale, scale, scale);
        
        GL11.glLight(GL11.GL_LIGHT0,
                     GL11.GL_POSITION,
                     lightPos);
        GL11.glLight(GL11.GL_LIGHT0,
                     GL11.GL_DIFFUSE,
                     lightColor);
        GL11.glLight(GL11.GL_LIGHT0,
                     GL11.GL_SPECULAR,
                     lightColor);

        GL11.glEnable(GL11.GL_LIGHTING);
	for (CelestialBody sat : satellites) {
	    sat.draw();
	}
        
	GL11.glRotatef(declination, 1f, 0f, 0f);
	GL11.glEnable(GL11.GL_BLEND);
	GL11.glDisable(GL11.GL_LIGHTING);
	GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE);
	GL11.glColor4f(red, green, blue, 0.5f);
	GL11.glScalef(0.8f, 0.8f, 0.8f);
	s.draw();
	GL11.glScalef(1.15f, 1.15f, 1.15f);
	s.draw();
	GL11.glScalef(1.1f, 1.1f, 1.1f);
	s.draw();
	GL11.glScalef(1.05f, 1.05f, 1.05f);
	s.draw();
	GL11.glScalef(1.01f, 1.01f, 1.01f);
	s.draw();
	GL11.glDisable(GL11.GL_BLEND);
        
	GL11.glPopMatrix();
	angularPos += speed;
    }
}